#version 120

#pragma includeshader data/shaders/noise3d.glsl

uniform float time;
uniform vec4 meshColor;

uniform int shadingEnable;

uniform int sheenEnable;
uniform vec4 sheenColor;

varying vec4 color;
varying vec3 normal;

varying vec3 pos;

vec3 lightNormal = normalize(vec3(0.8, 0.3, 1.0));
vec3 lightColor = vec3(1.0, 1.0, 1.0);

void main() {
  float shade = 1.0;

  if(shadingEnable == 1) {
      shade = (dot(normal, lightNormal) * 0.2) + 0.8;
  }

  vec4 sheen = vec4(0.0, 0.0, 0.0, 0.0);

  if(sheenEnable == 1) {
    sheen = sheenColor;;
    float sheenMult = pow(sin(((time * 3.0) - pos.z) * 0.5), 256.0);
    if(sheenMult < 0.0) {
      sheenMult = 0.0;
    }
    sheenMult = min(sheenMult, 1.0);
    float sheenBase = sin(time * 3.0) * 0.2 + 0.3;
    sheen *= (sheenMult + sheenBase) * sheenColor.a;
  }

  vec4 finalColor = vec4(color.rgb * lightColor * shade, color.a) * meshColor + sheen;

  if(0 == 1) {
    finalColor.r = pow(finalColor.r, 1/2.2);
    finalColor.g = pow(finalColor.g, 1/2.2);
    finalColor.b = pow(finalColor.b, 1/2.2);
  }

  gl_FragColor = finalColor;
}
