
#include <stdio.h>

#include "common.h"

// endian checking from Quake2

int SystemEndian;

short (*BigShort)    (short l);
short (*LittleShort) (short l);
int (*BigInt)    (int l);
int (*LittleInt) (int l);
float (*BigFloat)    (float l);
float (*LittleFloat) (float l);

short ShortSwap (short l)
{
  unsigned char b1, b2;

  b1 = l & 255;
  b2 = (l >> 8) & 255;

  return (b1 << 8) + b2;
}

short ShortNoSwap (short l)
{
  return l;
}

int IntSwap (int l)
{
  unsigned char b1, b2, b3, b4;

  b1 = l&255;
  b2 = (l>>8)&255;
  b3 = (l>>16)&255;
  b4 = (l>>24)&255;

  return ((int)b1<<24) + ((int)b2<<16) + ((int)b3<<8) + b4;
}

int IntNoSwap (int l)
{
  return l;
}
float FloatSwap (float f)
{
  union
  {
    float f;
    unsigned char b[4];
  } dat1, dat2;

  dat1.f = f;
  dat2.b[0] = dat1.b[3];
  dat2.b[1] = dat1.b[2];
  dat2.b[2] = dat1.b[1];
  dat2.b[3] = dat1.b[0];
  return dat2.f;
}

float FloatNoSwap (float f)
{
  return f;
}

int Common_Init(void) {
  unsigned char swaptest[2] = {1, 0};

  if(*(short *)swaptest == 1) { // little endian
    SystemEndian = ENDIAN_LITTLE;

    BigShort    = ShortSwap;
    LittleShort = ShortNoSwap;

    BigInt    = IntSwap;
    LittleInt = IntNoSwap;

    BigFloat    = FloatSwap;
    LittleFloat = FloatNoSwap;
  } else { // big endian
    SystemEndian = ENDIAN_BIG;

    BigShort    = ShortNoSwap;
    LittleShort = ShortSwap;

    BigInt    = IntNoSwap;
    LittleInt = IntSwap;

    BigFloat    = FloatNoSwap;
    LittleFloat = FloatSwap;
  }

  return 0;
}
