
#include <stdio.h>

#include "timer.h"
#include "model.h"

#include "game.h"

int Game_Init(void) {
  printf("\nStarting game...\n");

  // preload game models
  Model_LoadFromFile("data/models/shotgun.dmdl", MDL_SHOTGUN);

  // preload world models
  Model_LoadFromFile("data/models/lever.dmdl", MDL_LEVER);

  // preload map prefabs
  Model_LoadFromFile("data/prefabs/wall_1.dmdl", MDL_PREFAB_WALL_1);
  Model_LoadFromFile("data/prefabs/wall_2.dmdl", MDL_PREFAB_WALL_2);

  Model_LoadFromFile("data/prefabs/floor_2.dmdl", MDL_PREFAB_FLOOR_2);

  Model_LoadFromFile("data/prefabs/trim_1.dmdl", MDL_PREFAB_TRIM_1);
  Model_LoadFromFile("data/prefabs/trim_2.dmdl", MDL_PREFAB_TRIM_2);

  return 0;
}

int Game_DeInit(void) {
  return 0;
}

int Game_Frame(void) {
  return 0;
}

void Game_AfterFrame(void) {
}
