
#ifndef MODEL_H
#define MODEL_H

#define MAX_MODELS 1024 // large arbitrary number
#define MAX_FRAMES 256 // max amount of animation frames
#define MODEL_HEADER "DMDL01"

unsigned int Model_DisplayLists[MAX_MODELS][MAX_FRAMES];

enum {
  MDL_NONE = -1,

  // game models
  MDL_SHOTGUN = 0,
  MDL_GRENADE,

  MDL_HEALTHPICKUP,

  // world models
  MDL_LEVER,

  // prefabs
  MDL_PREFAB_WALL_1,
  MDL_PREFAB_WALL_2,

  MDL_PREFAB_FLOOR_2,

  MDL_PREFAB_TRIM_1,
  MDL_PREFAB_TRIM_2
} Model_IDs;

int Model_Init(void);

int Model_LoadFromFile(const char *path, int id);

#endif // MODEL_H
