
#include "SDL.h"
#include "SDL_timer.h"

#include "timer.h"

int Timer_Init (void) {
  timerData.millis = 0;
  timerData.lastMillis = 0;

  timerData.delta = 1000.0 / 60.0; // 60 fps delta for 1st frame

  timerData.lockFps = 1;
  timerData.fps = 60.0;

  return 0;
}

int Timer_Frame(void) {
  timerData.millis = SDL_GetTicks();
  timerData.delta = (timerData.millis - timerData.lastMillis) * 0.001;

  timerData.lastMillis = timerData.millis;

  timerData.fps = 1.0 / timerData.delta;

  if(timerData.lockFps && timerData.delta <= 1000.0 / 60.0)
    SDL_Delay((1000.0 / 60.0) - timerData.delta);

  return 0;
}

void Timer_AfterFrame(void) {
}
